commit:     d89ab6a7db111f7d697490087d01487671ece589
Author:     Matt Jolly <kangie <AT> gentoo <DOT> org>
AuthorDate: Fri May 30 09:35:01 2025 +0000
Commit:     Matt Jolly <kangie <AT> gentoo <DOT> org>
CommitDate: Fri May 30 11:44:46 2025 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=d89ab6a7

net-misc/curl: add 8.14.0

Signed-off-by: Matt Jolly <kangie <AT> gentoo.org>

 net-misc/curl/Manifest                             |   2 +
 net-misc/curl/curl-8.14.0.ebuild                   | 437 +++++++++++++++++++++
 .../files/curl-8.14.0-add_handle-resizing.patch    | 187 +++++++++
 3 files changed, 626 insertions(+)

diff --git a/net-misc/curl/Manifest b/net-misc/curl/Manifest
index acd8121c7e8d..ee9393b32910 100644
--- a/net-misc/curl/Manifest
+++ b/net-misc/curl/Manifest
@@ -6,3 +6,5 @@ DIST curl-8.14.0-rc2.tar.xz 2812028 BLAKE2B 
afd110e546d35b0c11879ec1b99e1783579b
 DIST curl-8.14.0-rc2.tar.xz.asc 488 BLAKE2B 
0a326bfee0ca400ad61b43a95a55a1f726d470d680352440710a1563d2987114357fabeb032860d585032cd7dca19082cb2840104a53f12dbea4dfed72edccae
 SHA512 
89d9c26200a2c1fee49782df396ba11b323debe7226441c4fa00eb96a0d245b47c157c84060bdd4d46105d8cdb7198639c42bcd1594c40318e31dc3f73f8e514
 DIST curl-8.14.0-rc3.tar.xz 2816044 BLAKE2B 
97c7269fff76e4c5e61f1e99e5f96a8a0428c329246da689b79d989ead9c5e5a79e520ce762b0cebfdbe3cb97bdac7c6d46f432cc2abf333cb2d1bb1581d8959
 SHA512 
aadbb930ca9515a51674230adefa5e5e3a74747d8e402830a49ed780986435a06e57e31e14b25dd8ebf63fc658feb1bd1d77f006487ccf26952456bf38377654
 DIST curl-8.14.0-rc3.tar.xz.asc 488 BLAKE2B 
0a79f17d90de77e2cf4f44c3e8fc12796c42b893b7cbdfcef30bff3d34cbe5f1f4ec3058ee554d89d1195b80a1287c133495bc95e17d66539b2fb9978b00a2ca
 SHA512 
96196422bb944cea65d5f4f2f54938bd6b90ab6a85bf84c55f805be03d9d10d6d37f3d814dd3adafd5e8a51c2c80d4e85ac97b33c2ba55a7d27f335ba2070e6b
+DIST curl-8.14.0.tar.xz 2819512 BLAKE2B 
d8b7d58e6923366265a1d95d3a6f14002729dfb95d88b17ec925d096bd199b206f6c9645e1e4be3bc2d295e8898c35990eda6f45329396f38753725907e402a1
 SHA512 
d9f49cac0b93dbc53879713cc017392b4277d84b489bbf2ef3b585c6a50eea6c3a7b80043286b34062af04329560f2dc321f315b0038ce93435aa9bbcaec1eea
+DIST curl-8.14.0.tar.xz.asc 488 BLAKE2B 
9fa2fe756d7c170b4fc883bd0c23eb103d947e8328d56ea3dea53403d3cd01626ada943595179955f55a77eb8f4da65b5e4d74fe5627fc8c5ab4d88efbb5df3e
 SHA512 
7c147ddb5e141dd9951e2ef6b23fa120318c0e631fb36861b80fce61b4b19ca08273a6b95627f46a8172945fb51bd790ffc74dee0a4b0de860dad518963b4710

diff --git a/net-misc/curl/curl-8.14.0.ebuild b/net-misc/curl/curl-8.14.0.ebuild
new file mode 100644
index 000000000000..db6300f056b3
--- /dev/null
+++ b/net-misc/curl/curl-8.14.0.ebuild
@@ -0,0 +1,437 @@
+# Copyright 1999-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+# Maintainers should subscribe to the 'curl-distros' ML for backports etc
+# https://daniel.haxx.se/blog/2024/03/25/curl-distro-report/
+# https://lists.haxx.se/listinfo/curl-distros
+
+VERIFY_SIG_OPENPGP_KEY_PATH=/usr/share/openpgp-keys/danielstenberg.asc
+inherit autotools multilib-minimal multiprocessing prefix toolchain-funcs 
verify-sig
+
+DESCRIPTION="A Client that groks URLs"
+HOMEPAGE="https://curl.se/";
+
+if [[ ${PV} == 9999 ]]; then
+       inherit git-r3
+       EGIT_REPO_URI="https://github.com/curl/curl.git";
+else
+       if [[ ${P} == *rc* ]]; then
+               CURL_URI="https://curl.se/rc/";
+               S="${WORKDIR}/${P//_/-}"
+       else
+               CURL_URI="https://curl.se/download/";
+               KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~loong ~m68k ~mips 
~ppc ~ppc64 ~riscv ~s390 ~sparc ~x86 ~amd64-linux ~x86-linux ~arm64-macos 
~ppc-macos ~x64-macos ~x64-solaris"
+       fi
+       SRC_URI="
+               ${CURL_URI}${P//_/-}.tar.xz
+               verify-sig? ( ${CURL_URI}${P//_/-}.tar.xz.asc )
+       "
+fi
+
+LICENSE="BSD curl ISC test? ( BSD-4 )"
+SLOT="0"
+IUSE="+adns +alt-svc brotli debug ech +ftp gnutls gopher +hsts +http2 +http3 
+httpsrr idn +imap kerberos ldap"
+IUSE+=" mbedtls +openssl +pop3 +psl +quic rtmp rustls samba sasl-scram +smtp 
ssh ssl static-libs test"
+IUSE+=" telnet +tftp +websockets zstd"
+# These select the default tls implementation / which quic impl to use
+IUSE+=" +curl_quic_openssl curl_quic_ngtcp2 curl_ssl_gnutls curl_ssl_mbedtls 
+curl_ssl_openssl curl_ssl_rustls"
+RESTRICT="!test? ( test )"
+
+# HTTPS RR is technically usable with the threaded resolver, but it still uses 
c-ares to
+# ask for the HTTPS RR record type; if DoH is in use the HTTPS record will be 
requested
+# in addition to A and AAAA records.
+
+# To simplify dependency management in the ebuild we'll require c-ares for 
HTTPS RR (for now?).
+# HTTPS RR in cURL is a dependency for:
+# - ECH (requires patched openssl or gnutls currently, enabled with rustls)
+# - Fetching the ALPN list which should provide a better HTTP/3 experience.
+
+# Only one default ssl / quic provider can be enabled
+# The default provider needs its USE satisfied
+# HTTP/3 and MultiSSL are mutually exclusive; it's not clear if MultiSSL 
offers any benefit at all in the modern day.
+# https://github.com/curl/curl/commit/65ece771f4602107d9cdd339dff4b420280a2c2e
+REQUIRED_USE="
+       ech? ( rustls )
+       httpsrr? ( adns )
+       quic? (
+               ^^ (
+                       curl_quic_openssl
+                       curl_quic_ngtcp2
+               )
+               http3
+               ssl
+       )
+       ssl? (
+               ^^ (
+                       curl_ssl_gnutls
+                       curl_ssl_mbedtls
+                       curl_ssl_openssl
+                       curl_ssl_rustls
+               )
+       )
+       curl_quic_openssl? (
+               curl_ssl_openssl
+               quic
+               !gnutls
+               !mbedtls
+               !rustls
+       )
+       curl_quic_ngtcp2? (
+               curl_ssl_gnutls
+               quic
+               !mbedtls
+               !openssl
+               !rustls
+       )
+       curl_ssl_gnutls? ( gnutls )
+       curl_ssl_mbedtls? ( mbedtls )
+       curl_ssl_openssl? ( openssl )
+       curl_ssl_rustls? ( rustls )
+       http3? ( alt-svc httpsrr quic )
+"
+
+# cURL's docs and CI/CD are great resources for confirming supported versions
+# particulary for fast-moving targets like HTTP/2 and TCP/2 e.g.:
+# - https://github.com/curl/curl/blob/master/docs/INTERNALS.md (core 
dependencies + minimum versions)
+# - https://github.com/curl/curl/blob/master/docs/HTTP3.md (example of a 
feature that moves quickly)
+# - https://github.com/curl/curl/blob/master/.github/workflows/http3-linux.yml 
(CI/CD for TCP/2)
+# However 'supported' vs 'works' are two entirely different things; be sane but
+# don't be afraid to require a later version.
+# ngtcp2 = https://bugs.gentoo.org/912029 - can only build with one tls 
backend at a time.
+RDEPEND="
+       >=sys-libs/zlib-1.2.5[${MULTILIB_USEDEP}]
+       adns? ( >=net-dns/c-ares-1.16.0:=[${MULTILIB_USEDEP}] )
+       brotli? ( app-arch/brotli:=[${MULTILIB_USEDEP}] )
+       http2? ( >=net-libs/nghttp2-1.15.0:=[${MULTILIB_USEDEP}] )
+       http3? ( >=net-libs/nghttp3-1.1.0[${MULTILIB_USEDEP}] )
+       idn? ( >=net-dns/libidn2-2.0.0:=[static-libs?,${MULTILIB_USEDEP}] )
+       kerberos? ( >=virtual/krb5-0-r1[${MULTILIB_USEDEP}] )
+       ldap? ( >=net-nds/openldap-2.0.0:=[static-libs?,${MULTILIB_USEDEP}] )
+       psl? ( net-libs/libpsl[${MULTILIB_USEDEP}] )
+       quic? (
+               curl_quic_openssl? ( 
>=dev-libs/openssl-3.3.0:=[quic,${MULTILIB_USEDEP}] )
+               curl_quic_ngtcp2? ( 
>=net-libs/ngtcp2-1.2.0[gnutls,ssl,-openssl,${MULTILIB_USEDEP}] )
+       )
+       rtmp? ( media-video/rtmpdump[${MULTILIB_USEDEP}] )
+       ssh? ( >=net-libs/libssh2-1.2.8[${MULTILIB_USEDEP}] )
+       sasl-scram? ( >=net-misc/gsasl-2.2.0[static-libs?,${MULTILIB_USEDEP}] )
+       ssl? (
+               gnutls? (
+                       app-misc/ca-certificates
+                       
>=net-libs/gnutls-3.1.10:=[static-libs?,${MULTILIB_USEDEP}]
+                       dev-libs/nettle:=[${MULTILIB_USEDEP}]
+               )
+               mbedtls? (
+                       app-misc/ca-certificates
+                       net-libs/mbedtls:0=[${MULTILIB_USEDEP}]
+               )
+               openssl? (
+                       
>=dev-libs/openssl-1.0.2:=[static-libs?,${MULTILIB_USEDEP}]
+               )
+               rustls? (
+                       >=net-libs/rustls-ffi-0.15.0:=[${MULTILIB_USEDEP}]
+               )
+       )
+       zstd? ( app-arch/zstd:=[${MULTILIB_USEDEP}] )
+"
+
+DEPEND="${RDEPEND}"
+
+BDEPEND="
+       dev-lang/perl
+       virtual/pkgconfig
+       test? (
+               sys-apps/diffutils
+               http2? ( >=net-libs/nghttp2-1.15.0:=[utils,${MULTILIB_USEDEP}] )
+               http3? ( net-libs/nghttp2:=[utils,${MULTILIB_USEDEP}] )
+       )
+       verify-sig? ( sec-keys/openpgp-keys-danielstenberg )
+"
+
+DOCS=( README docs/{FEATURES.md,INTERNALS.md,FAQ,BUGS.md,CONTRIBUTE.md} )
+
+MULTILIB_WRAPPED_HEADERS=(
+       /usr/include/curl/curlbuild.h
+)
+
+MULTILIB_CHOST_TOOLS=(
+       /usr/bin/curl-config
+)
+
+QA_CONFIG_IMPL_DECL_SKIP=(
+       __builtin_available
+       closesocket
+       CloseSocket
+       getpass_r
+       ioctlsocket
+       IoctlSocket
+       mach_absolute_time
+       setmode
+       _fseeki64
+       # custom AC_LINK_IFELSE code fails to link even without -Werror
+       OSSL_QUIC_client_method
+)
+
+PATCHES=(
+       "${FILESDIR}/${PN}-prefix-4.patch"
+       "${FILESDIR}/${PN}-respect-cflags-3.patch"
+       "${FILESDIR}/${P}-add_handle-resizing.patch"
+)
+
+src_prepare() {
+       default
+
+       eprefixify curl-config.in
+       eautoreconf
+}
+
+# Generates TLS-related configure options based on USE flags.
+# Outputs options suitable for appending to a configure options array.
+_get_curl_tls_configure_opts() {
+       local tls_opts=()
+
+       local backend flag_name
+       for backend in gnutls mbedtls openssl rustls; do
+               if [[ "$backend" == "openssl" ]]; then
+                       flag_name="ssl"
+                       tls_opts+=( "--with-ca-path=${EPREFIX}/etc/ssl/certs")
+               else
+                       flag_name="$backend"
+               fi
+
+               if use "$backend"; then
+                       tls_opts+=( "--with-${flag_name}" )
+               else
+                       # If a single backend is enabled, 'ssl' is required, 
openssl is the default / fallback
+                       if ! [[ "$backend" == "openssl" ]]; then
+                               tls_opts+=( "--without-${flag_name}" )
+                       fi
+               fi
+       done
+
+       if use curl_ssl_gnutls; then
+               multilib_is_native_abi && einfo "Default TLS backend: gnutls"
+               tls_opts+=( "--with-default-ssl-backend=gnutls" )
+       elif use curl_ssl_mbedtls; then
+               multilib_is_native_abi && einfo "Default TLS backend: mbedtls"
+               tls_opts+=( "--with-default-ssl-backend=mbedtls" )
+       elif use curl_ssl_openssl; then
+               multilib_is_native_abi && einfo "Default TLS backend: openssl"
+               tls_opts+=( "--with-default-ssl-backend=openssl" )
+       elif use curl_ssl_rustls; then
+               multilib_is_native_abi && einfo "Default TLS backend: rustls"
+               tls_opts+=( "--with-default-ssl-backend=rustls" )
+       else
+               eerror "We can't be here because of REQUIRED_USE."
+               die "Please file a bug, hit impossible condition w/ USE=ssl 
handling."
+       fi
+
+       # Explicitly Disable unimplemented b
+       tls_opts+=(
+               --without-amissl
+               --without-bearssl
+               --without-wolfssl
+       )
+
+       printf "%s\n" "${tls_opts[@]}"
+}
+
+multilib_src_configure() {
+       # We make use of the fact that later flags override earlier ones
+       # So start with all ssl providers off until proven otherwise
+       # TODO: in the future, we may want to add wolfssl 
(https://www.wolfssl.com/)
+       local myconf=()
+
+       myconf+=( --without-ca-fallback 
--with-ca-bundle="${EPREFIX}"/etc/ssl/certs/ca-certificates.crt  )
+       if use ssl; then
+               local -a tls_backend_opts
+               readarray -t tls_backend_opts < <(_get_curl_tls_configure_opts)
+               myconf+=("${tls_backend_opts[@]}")
+       else
+               myconf+=( --without-ssl )
+               einfo "SSL disabled"
+       fi
+
+       # These configuration options are organised alphabetically by 
category/type
+
+       # Protocols
+       # `grep SUPPORT_PROTOCOLS=\" configure.ac | awk '{ print substr($2, 1, 
length($2)-1)}' | sort`
+       # Assume that anything omitted (that is not new!) is enabled by default 
with no deps
+       myconf+=(
+               --enable-file
+               $(use_enable ftp)
+               $(use_enable gopher)
+               --enable-http
+               $(use_enable imap) # Automatic IMAPS if TLS is enabled
+               $(use_enable ldap ldaps)
+               $(use_enable ldap)
+               $(use_enable pop3)
+               $(use_enable samba smb)
+               $(use_with ssh libssh2) # enables scp/sftp
+               $(use_with rtmp librtmp)
+               --enable-rtsp
+               $(use_enable smtp)
+               $(use_enable telnet)
+               $(use_enable tftp)
+               $(use_enable websockets)
+       )
+
+       # Keep various 'HTTP-flavoured' options together
+       myconf+=(
+               $(use_enable alt-svc)
+               $(use_enable hsts)
+               $(use_enable httpsrr)
+               $(use_with http2 nghttp2)
+               $(use_with http3 nghttp3)
+               $(use_with curl_quic_ngtcp2 ngtcp2)
+               $(use_with curl_quic_openssl openssl-quic)
+       )
+
+       # --enable/disable options
+       # `grep -- --enable configure | grep Check | awk '{ print $4 }' | sort`
+       myconf+=(
+               $(use_enable adns ares)
+               --enable-aws
+               --enable-basic-auth
+               --enable-bearer-auth
+               --enable-cookies
+               --enable-dateparse
+               --enable-dict
+               --enable-digest-auth
+               --enable-dnsshuffle
+               --enable-doh
+               $(use_enable ech)
+               --enable-http-auth
+               --enable-ipv6
+               --enable-kerberos-auth
+               --enable-largefile
+               --enable-manual
+               --enable-mime
+               --enable-negotiate-auth
+               --enable-netrc
+               --enable-ntlm
+               --enable-progress-meter
+               --enable-proxy
+               --enable-rt
+               --enable-socketpair
+               --disable-sspi
+               $(use_enable static-libs static)
+               --enable-symbol-hiding
+               --enable-tls-srp
+               --disable-versioned-symbols
+       )
+
+       # --with/without options
+       # `grep -- --with configure | grep Check | awk '{ print $4 }' | sort`
+       myconf+=(
+               $(use_with brotli)
+               
--with-fish-functions-dir="${EPREFIX}"/usr/share/fish/vendor_completions.d
+               $(use_with idn libidn2)
+               $(use_with kerberos gssapi "${EPREFIX}"/usr)
+               $(use_with sasl-scram libgsasl)
+               $(use_with psl libpsl)
+               --without-msh3
+               --without-quiche
+               --without-schannel
+               --without-secure-transport
+               --without-winidn
+               --with-zlib
+               
--with-zsh-functions-dir="${EPREFIX}"/usr/share/zsh/site-functions
+               $(use_with zstd)
+       )
+
+       # Test deps (disabled)
+       myconf+=(
+               --without-test-caddy
+               --without-test-httpd
+               --without-test-nghttpx
+       )
+
+       if use debug; then
+               myconf+=(
+                       --enable-debug
+               )
+       fi
+
+       if use test && multilib_is_native_abi && ( use http2 || use http3 ); 
then
+               myconf+=(
+                       --with-test-nghttpx="${BROOT}/usr/bin/nghttpx"
+               )
+       fi
+
+       # Since 8.12.0 adns/c-ares and the threaded resolver are mutually 
exclusive
+       # This is in support of some work to enable `httpsrr` to use adns and 
the rest
+       # of curl to use the threaded resolver; for us `httpsrr` is conditional 
on adns.
+       if use adns; then
+               myconf+=(
+                       --disable-threaded-resolver
+               )
+       else
+               myconf+=(
+                       --enable-threaded-resolver
+               )
+       fi
+
+       ECONF_SOURCE="${S}" econf "${myconf[@]}"
+
+       if ! multilib_is_native_abi; then
+               # Avoid building the client (we just want libcurl for multilib)
+               sed -i -e '/SUBDIRS/s:src::' Makefile || die
+               sed -i -e '/SUBDIRS/s:scripts::' Makefile || die
+       fi
+
+}
+
+multilib_src_compile() {
+       default
+
+       if multilib_is_native_abi; then
+               # Shell completions
+               ! tc-is-cross-compiler && emake -C scripts
+       fi
+}
+
+# There is also a pytest harness that tests for bugs in some very specific
+# situations; we can rely on upstream for this rather than adding additional 
test deps.
+multilib_src_test() {
+       # See https://github.com/curl/curl/blob/master/tests/runtests.pl#L5721
+       # -n: no valgrind (unreliable in sandbox and doesn't work correctly on 
all arches)
+       # -v: verbose
+       # -a: keep going on failure (so we see everything that breaks, not just 
1st test)
+       # -k: keep test files after completion
+       # -am: automake style TAP output
+       # -p: print logs if test fails
+       # Note: if needed, we can skip specific tests. See e.g. Fedora's 
packaging
+       # or just read https://github.com/curl/curl/tree/master/tests#run.
+       # Note: we don't run the testsuite for cross-compilation.
+       # Upstream recommend 7*nproc as a starting point for parallel tests, but
+       # this ends up breaking when nproc is huge (like -j80).
+       # The network sandbox causes tests 241 and 1083 to fail; these are 
typically skipped
+       # as most gentoo users don't have an 'ip6-localhost'
+       multilib_is_native_abi && emake test TFLAGS="-n -v -a -k -am -p 
-j$((2*$(makeopts_jobs))) !241 !1083"
+}
+
+multilib_src_install() {
+       emake DESTDIR="${D}" install
+
+       if multilib_is_native_abi; then
+               # Shell completions
+               ! tc-is-cross-compiler && emake -C scripts DESTDIR="${D}" 
install
+       fi
+}
+
+multilib_src_install_all() {
+       einstalldocs
+       find "${ED}" -type f -name '*.la' -delete || die
+       rm -rf "${ED}"/etc/ || die
+}
+
+pkg_postinst() {
+       if use debug; then
+               ewarn "USE=debug has been selected, enabling debug codepaths 
and making cURL extra verbose."
+               ewarn "Use this _only_ for testing. Debug builds should _not_ 
be used in anger."
+               ewarn "hic sunt dracones; you have been warned."
+       fi
+}

diff --git a/net-misc/curl/files/curl-8.14.0-add_handle-resizing.patch 
b/net-misc/curl/files/curl-8.14.0-add_handle-resizing.patch
new file mode 100644
index 000000000000..0bbf0262bd16
--- /dev/null
+++ b/net-misc/curl/files/curl-8.14.0-add_handle-resizing.patch
@@ -0,0 +1,187 @@
+https://github.com/curl/curl/commit/d16ccbd55de80c271fe822f4ba8b6271fd9166ff
+From: Stefan Eissing <[email protected]>
+Date: Wed, 28 May 2025 14:04:31 +0200
+Subject: [PATCH] multi: fix add_handle resizing
+
+Due to someone being stupid, the resizing of the multi's transfer
+table was actually shrinking it. Oh my.
+
+Add test751 to reproduce, add code assertion.
+
+Fixes #17473
+Reported-by: Jeroen Ooms
+Closes #17475
+--- a/lib/multi.c
++++ b/lib/multi.c
+@@ -347,7 +347,8 @@ static CURLMcode multi_xfers_add(struct Curl_multi *multi,
+   if(unused <= min_unused) {
+      /* make it a 64 multiple, since our bitsets frow by that and
+       * small (easy_multi) grows to at least 64 on first resize. */
+-    unsigned int newsize = ((capacity + min_unused) + 63) / 64;
++    unsigned int newsize = (((capacity + min_unused) + 63) / 64) * 64;
++    DEBUGASSERT(newsize > capacity);
+     /* Grow the bitsets first. Should one fail, we do not need
+      * to downsize the already resized ones. The sets continue
+      * to work properly when larger than the table, but not
+--- a/tests/data/Makefile.am
++++ b/tests/data/Makefile.am
+@@ -107,7 +107,7 @@ test709 test710 test711 test712 test713 test714 test715 
test716 test717 \
+ test718 test719 test720 test721 test722 test723 test724 test725 test726 \
+ test727 test728 test729 test730 test731 test732 test733 test734 test735 \
+ test736 test737 test738 test739 test740 test741 test742 test743 test744 \
+-test745 test746 test747 test748 test749 test750 \
++test745 test746 test747 test748 test749 test750 test751 \
+ \
+ test780 test781 test782 test783 test784 test785 test786 test787 test788 \
+ test789 test790 test791 \
+--- /dev/null
++++ b/tests/data/test751
+@@ -0,0 +1,33 @@
++<testcase>
++<info>
++<keywords>
++MULTI
++</keywords>
++</info>
++<reply>
++<data>
++</data>
++</reply>
++
++# Client-side
++<client>
++<server>
++none
++</server>
++# tool is what to use instead of 'curl'
++<tool>
++lib%TESTNUMBER
++</tool>
++
++<name>
++multi - add many easy handles
++</name>
++<command>
++</command>
++</file>
++</client>
++
++# Verify data after the test has been "shot"
++<verify>
++</verify>
++</testcase>
+--- a/tests/libtest/Makefile.inc
++++ b/tests/libtest/Makefile.inc
+@@ -50,6 +50,7 @@ LIBTESTPROGS = libauthretry libntlmconnect libprereq         
            \
+  lib659 lib661 lib666 lib667 lib668 \
+  lib670 lib671 lib672 lib673 lib674 lib676 lib677 lib678 lib694 lib695   \
+  lib696 \
++ lib751 \
+  lib1156 \
+  lib1301 \
+  lib1308 \
+@@ -349,6 +350,9 @@ lib695_SOURCES = lib695.c $(SUPPORTFILES)
+ lib696_SOURCES = lib556.c $(SUPPORTFILES) $(WARNLESS)
+ lib696_CPPFLAGS = $(AM_CPPFLAGS) -DLIB696
+ 
++lib751_SOURCES = lib751.c $(SUPPORTFILES) $(TESTUTIL) $(WARNLESS)
++lib751_LDADD = $(TESTUTIL_LIBS)
++
+ lib1301_SOURCES = lib1301.c $(SUPPORTFILES) $(TESTUTIL)
+ lib1301_LDADD = $(TESTUTIL_LIBS)
+ 
+--- /dev/null
++++ b/tests/libtest/lib751.c
+@@ -0,0 +1,92 @@
++/***************************************************************************
++ *                                  _   _ ____  _
++ *  Project                     ___| | | |  _ \| |
++ *                             / __| | | | |_) | |
++ *                            | (__| |_| |  _ <| |___
++ *                             \___|\___/|_| \_\_____|
++ *
++ * Copyright (C) Daniel Stenberg, <[email protected]>, et al.
++ *
++ * This software is licensed as described in the file COPYING, which
++ * you should have received as part of this distribution. The terms
++ * are also available at https://curl.se/docs/copyright.html.
++ *
++ * You may opt to use, copy, modify, merge, publish, distribute and/or sell
++ * copies of the Software, and permit persons to whom the Software is
++ * furnished to do so, under the terms of the COPYING file.
++ *
++ * This software is distributed on an "AS IS" basis, WITHOUT WARRANTY OF ANY
++ * KIND, either express or implied.
++ *
++ * SPDX-License-Identifier: curl
++ *
++ ***************************************************************************/
++#include "test.h"
++
++#include "testutil.h"
++#include "warnless.h"
++#include "memdebug.h"
++
++#define TEST_HANG_TIMEOUT 60 * 1000
++
++/*
++ * Get a single URL without select().
++ */
++
++CURLcode test(char *URL)
++{
++  CURL *easies[1000];
++  CURLM *m;
++  CURLcode res = CURLE_FAILED_INIT;
++  CURLMcode mres;
++  int i;
++
++  (void)URL;
++  memset(easies, 0, sizeof(easies));
++
++  curl_global_init(CURL_GLOBAL_DEFAULT);
++  m = curl_multi_init();
++  if(!m) {
++    res = CURLE_OUT_OF_MEMORY;
++    goto test_cleanup;
++  }
++
++  for(i = 0; i < 1000; i++) {
++    CURL *e = curl_easy_init();
++    if(!e) {
++      res = CURLE_OUT_OF_MEMORY;
++      goto test_cleanup;
++    }
++    easies[i] = e;
++
++    res = curl_easy_setopt(e, CURLOPT_URL, "https://www.example.com/";);
++    if(!res)
++      res = curl_easy_setopt(e, CURLOPT_VERBOSE, 1L);
++    if(res)
++      goto test_cleanup;
++
++    mres = curl_multi_add_handle(m, e);
++    if(mres != CURLM_OK) {
++      printf("MULTI ERROR: %s\n", curl_multi_strerror(mres));
++      res = CURLE_FAILED_INIT;
++      goto test_cleanup;
++    }
++  }
++
++test_cleanup:
++
++  if(res)
++    printf("ERROR: %s\n", curl_easy_strerror(res));
++
++  for(i = 0; i < 1000; i++) {
++    if(easies[i]) {
++      curl_multi_add_handle(m, easies[i]);
++      curl_easy_cleanup(easies[i]);
++      easies[i] = NULL;
++    }
++  }
++  curl_multi_cleanup(m);
++  curl_global_cleanup();
++
++  return res;
++}

Reply via email to